# FILE: mmArchive.tcl
#

# Set up for auto-loading
set master(relhdir) [string trimright [file dirname [info script]] ./]
set master(abshdir) [file join [pwd] $master(relhdir)]
set master(pdir) [file dirname $master(abshdir)]
set master(libdir) [file dirname $master(pdir)]
if {[lsearch $auto_path $master(libdir)] < 0} {
    lappend auto_path $master(libdir)
}

# Support libraries
package require Tk
package require Oc 
package require Net
package require Ow

# Death
proc Die { win } {
    if {![string match "." $win]} { return }  ;# Child destroy event
    global protocol
    if {[info exists protocol]} {
	$protocol Delete; after 2000 exit
    } else {
	exit
    }
}
bind . <Destroy> {+Die %W}

Oc_Main SetAppName mmArchive
Oc_Main SetVersion 1.0.1.0
regexp \\\044Date:(.*)\\\044 {$Date: 1998/10/05 20:37:07 $} _ date
Oc_Main SetDate [string trim $date]
# regexp \\\044Author:(.*)\\\044 {$Author: dgp $} _ author
# Oc_Main SetAuthor [Oc_Person Lookup [string trim $author]]
Oc_Main SetAuthor [Oc_Person Lookup dgp]
Oc_Main SetHelpURL [Oc_Url FromFilename [file join [file dirname \
        [file dirname [file dirname [file dirname [Oc_DirectPathname \
        [info script]]]]]] doc userguide Data_Archive_mmArchive.html]]

# Menu bar
set menubar .mb
foreach {fmenu hmenu} [Ow_MakeMenubar . $menubar File Help] {}
$fmenu add command -label "Exit" -command { Die . } -underline 1
Ow_StdHelpMenu $hmenu

if {$tk_version>=8.0 && [string match windows $tcl_platform(platform)]} {
    # Windows doesn't size Tcl 8.0 menubar cleanly
    Oc_DisableAutoSize .
    wm geometry . "[Ow_GuessMenuWidth $menubar]x1"
    update
    wm geometry . {}
    Oc_EnableAutoSize .
    update
}

Ow_Log New log -dateformat "" -title [Oc_Main GetAppName]<[pid]>
Net_Protocol New protocol -name "OOMMF vectorField protocol 0.0"
$protocol AddMessage start datafile { fnlist } {
    set tmpfile [lindex $fnlist 0]
    set permfile [lindex $fnlist 1]
    global log
    $log Append "Writing $permfile ..."
    # Ought to add lots of error checking here...
    file rename -force $tmpfile $permfile
    return [list start [list 0 0]]
}
$protocol AddMessage start HasGui {} {
    return [list start [list 0 0]]
}
Net_Server New server -protocol $protocol -alias [Oc_Main GetAppName] \
        -log Oc_Nop
$server Start 0
wm title . [Oc_Main GetAppName]<[pid]>
Ow_SetIcon .
# Improve this later:
em_eventHandler new $log delete { after 2000 exit }
vwait forever
